unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, Mask, BusinessSkinForm, bsSkinCtrls;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    CbBoxShouNian: TComboBox;
    DTP_1: TDateTimePicker;
    DTP_3: TDateTimePicker;
    CbBox_1: TComboBox;
    ST_nian: TStaticText;
    ST_nianzhi: TStaticText;
    Btn_Do: TBitBtn;
    Label8: TLabel;
    CbBox_AppType: TComboBox;
    bsBusinessSkinForm1: TbsBusinessSkinForm;
    bsSkinLabel1: TbsSkinLabel;
    bsSkinExPanel1: TbsSkinExPanel;
    bsSkinRichEdit1: TbsSkinRichEdit;
    procedure DTP_3Exit(Sender: TObject);
    procedure Btn_DoClick(Sender: TObject);
    procedure DTP_3KeyPress(Sender: TObject; var Key: Char);
    procedure DTP_1KeyPress(Sender: TObject; var Key: Char);
    procedure CbBox_1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure CbBoxShouNianKeyPress(Sender: TObject; var Key: Char);
    procedure CbBoxShouNianExit(Sender: TObject);
    procedure Btn_CloseClick(Sender: TObject);
    procedure CbBox_1Change(Sender: TObject);
    procedure CbBox_AppTypeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function feenian(apptype,nian,flag:integer):integer;
    function domonth(dt1,dt2:TDateTime;ii:integer):integer;
    function doyear(dt1,dt2:TDateTime;ii:integer):integer;
    procedure feeshow(apptype,firstnian,niandu,nianzhi,nianflag,fjflag:integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DTP_1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
    CbBoxShouNian.SetFocus;
end;

procedure TForm1.CbBoxShouNianKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
    DTP_3.SetFocus;
end;


procedure TForm1.CbBoxShouNianExit(Sender: TObject);
var
  i:integer;
begin
  try
    i:=strtoint(trim(CbBoxShouNian.text));
    if (i<1)or(i>20) then
    begin
      ShowMessage('ȳΧ(1-20)');
      CbBoxShouNian.SetFocus;
      Exit;
    end;
  except
    ShowMessage('ȣ');
    CbBoxShouNian.SetFocus;
    exit;
  end;

end;

procedure TForm1.DTP_3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
    CbBox_1.SetFocus;
end;

procedure TForm1.CbBox_1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
    Btn_Do.SetFocus;
end;

procedure TForm1.DTP_3Exit(Sender: TObject);
begin
  if (DTP_3.Date>33970)and(DTP_3.Date<34578) then ///1993-01-011994-09-01֮
  begin
    CbBox_1.Items.Clear;
    CbBox_1.Items.Add('0: ޼');
    CbBox_1.Items.Add('1:  75% ');
    CbBox_1.Items.Add('2:  50% ');
    CbBox_1.ItemIndex:=0;
  end else
  if (DTP_3.Date>34578)and(DTP_3.Date<36951) then ///1994-09-012001-03-01֮
  begin
    CbBox_1.Items.Clear;
    CbBox_1.Items.Add('0: ޼');
    CbBox_1.Items.Add('1:  80% ');
    CbBox_1.Items.Add('2:  60% ');
    CbBox_1.ItemIndex:=0;
  end else
  if DTP_3.Date>36951 then   ///2001-03-01֮
  begin
    CbBox_1.Items.Clear;
    CbBox_1.Items.Add('0: ޼');
    CbBox_1.Items.Add('1:  85% ');
    CbBox_1.Items.Add('2:  70% ');
    CbBox_1.ItemIndex:=0;
  end else
  begin   ///1993-01-01֮ǰ
    CbBox_1.Items.Clear;
    CbBox_1.Items.Add('0: ޼');
    CbBox_1.ItemIndex:=0;
    ShowMessage('޷õѼ');
  end;
end;

function TForm1.doyear(dt1,dt2:TDateTime;ii:integer):integer;
var
  i:Integer;
begin
  for i:=1 to 20 do
  begin
    if dt2<=IncMonth(dt1,12*i+ii) then
     Break;
  end;
  doyear:=i;
end;

function TForm1.domonth(dt1,dt2:TDateTime;ii:integer):integer;
var
  i:Integer;
begin
  for i:=1 to 6 do
  begin
    if dt2<=IncMonth(dt1,12*ii+i-12) then
     Break;
  end;
  domonth:=i-1;
end;

function TForm1.feenian(apptype,nian,flag:integer):integer;
begin
  if apptype=0 then
  begin
    if flag=1 then
    begin
      case nian of
        1..3:    feenian:=400;
        4..6:    feenian:=600;
        7..9:    feenian:=800;
        10..12:  feenian:=1500;
        13..15:  feenian:=3000;
        16..20:  feenian:=6000;
        else     feenian:=0;
      end;
    end else
    if flag=2 then
    begin
      case nian of
        1..3:    feenian:=600;
        4..6:    feenian:=900;
        7..9:    feenian:=1200;
        10..12:  feenian:=2000;
        13..15:  feenian:=4000;
        16..20:  feenian:=8000;
        else     feenian:=0;
      end;
    end else
    if flag=3 then
    begin
      case nian of
        1..3:    feenian:=900;
        4..6:    feenian:=1200;
        7..9:    feenian:=2000;
        10..12:  feenian:=4000;
        13..15:  feenian:=6000;
        16..20:  feenian:=8000;
        else     feenian:=0;
      end;
    end;
  end else
  if (apptype=1)or(apptype=2) then
  begin
    case nian of
      1..3:    feenian:=600;
      4..5:    feenian:=900;
      6..8:    feenian:=1200;
      9..10:  feenian:=2000;
      else     feenian:=0;
    end;
  end;
end;
 //˺йfirstnianж,ɽļ⣬ʱ򲻼
procedure TForm1.feeshow(apptype,firstnian,niandu,nianzhi,nianflag,fjflag:integer);
var
  feenianzhi:Integer;
begin
 ///*********************ѼΪ0*************************/////////
  //ѼΪ0Ѿ3
  if (fjflag=0)or(nianzhi-firstnian>2) then
  begin
     //ǰΪ
    if firstnian=niandu then
      ST_nian.Caption:='-'+IntToStr(niandu)+':'+IntToStr(feenian(apptype,niandu,nianflag))+'Ԫ'
    else
     //ǰ겻Ϊ
      ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr(feenian(apptype,niandu,nianflag))+'Ԫ';
     //ɽȲڵǰɷȣһnianzhinianduС1
     //ɽ
    if nianzhi<>niandu then
    begin
      if (nianflag=3) then
        feenianzhi:=feenian(apptype,nianzhi,nianflag)*domonth(DTP_1.Date,DTP_3.Date,nianzhi)div 20
      else
        feenianzhi:=feenian(apptype,nianzhi,nianflag) div 4;

  //Ȩ3꣨ѼΪ0  ??????????
    //  if nianzhi-firstnian<=2 then
      ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr(feenian(apptype,nianzhi,nianflag))+'Ԫ,:'
                          +IntToStr(feenianzhi)+'Ԫ';
    end else   //nianzhi=niandu
      ST_nianzhi.Caption:='ͷ';
    if niandu=2 then
      ST_nianzhi.Caption:='1:'+IntToStr(feenian(apptype,1,nianflag))+'Ԫ,:0Ԫ';
  end;
  //end if ѼΪ0Ѿ3
  //󲻵3꣬ѼЧ
  if nianzhi-firstnian<=2 then
  begin
  ///*********************ѼΪ1*************************//////////
    if fjflag=1 then
    begin
      if nianflag=3 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*3) div 20)+'Ԫ'
      else if nianflag=2 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*4) div 20)+'Ԫ'
      else if nianflag=1 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*5) div 20)+'Ԫ';

      if firstnian=niandu then
        ST_nian.Caption:='-'+ST_nian.Caption;

      if nianzhi<>niandu then
      begin
        if nianflag=3 then
          feenianzhi:=feenian(apptype,nianzhi,nianflag)*domonth(DTP_1.Date,DTP_3.Date,nianzhi)div 20
        else
          feenianzhi:=feenian(apptype,nianzhi,nianflag) div 4;

        if nianzhi-firstnian<=2 then
        begin
          if nianflag=3 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*3) div 20)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ'
          else if nianflag=2 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*4) div 20)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ'
          else if nianflag=1 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*5) div 20)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ';
        end;
      end else
        ST_nianzhi.Caption:='ͷ';
      if niandu=2 then
        ST_nianzhi.Caption:='1:'+IntToStr(feenian(apptype,1,nianflag))+'Ԫ,:0Ԫ';
    end else
     ///*********************ѼΪ2*************************/////////
    if fjflag=2 then
    begin
      if nianflag=3 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*3) div 10)+'Ԫ'
      else if nianflag=2 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*4) div 10)+'Ԫ'
      else if nianflag=1 then
        ST_nian.Caption:=''+IntToStr(niandu)+':'+IntToStr((feenian(apptype,niandu,nianflag)*5) div 10)+'Ԫ';

      if firstnian=niandu then
        ST_nian.Caption:='-'+ST_nian.Caption;

      if nianzhi<>niandu then
      begin
        if nianflag=3 then
          feenianzhi:=feenian(apptype,nianzhi,nianflag)*domonth(DTP_1.Date,DTP_3.Date,nianzhi)div 20
        else
          feenianzhi:=feenian(apptype,nianzhi,nianflag) div 4;

        if nianzhi-firstnian<=2 then
        begin
          if nianflag=3 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*3) div 10)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ'
          else if nianflag=2 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*4) div 10)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ'
          else if nianflag=1 then
            ST_nianzhi.Caption:=''+IntToStr(nianzhi)+':'+IntToStr((feenian(apptype,nianzhi,nianflag)*5) div 10)+'Ԫ,:'
                                +IntToStr(feenianzhi)+'Ԫ';
        end;
      end else
        ST_nianzhi.Caption:='ͷ';
      if niandu=2 then
        ST_nianzhi.Caption:='1:'+IntToStr(feenian(apptype,1,nianflag))+'Ԫ,:0Ԫ';
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CbBox_AppType.ItemIndex:=0;
  DTP_3.DateTime:=Now;
  DTP_3Exit(self);
  CbBoxShouNian.ItemIndex:=0;
  CbBox_1.ItemIndex:=0;
  CbBoxShouNian.Enabled:=False;
end;

procedure TForm1.Btn_DoClick(Sender: TObject);
var
  apptype:integer;
  niandu,nianzhi:integer;
  feenianzhi:integer;
  i,j,k:integer;
  FirstTime:TDateTime;
  firstnian:integer;
begin
  ST_nian.Caption:='';
  ST_nianzhi.Caption:='';
  apptype:=CbBox_AppType.ItemIndex;
  try
    firstnian:=strtoint(trim(CbBoxShouNian.text));
  except
    ShowMessage('!');
    exit;
  end;
  if CbBox_1.ItemIndex=-1 then
  begin
    ShowMessage('ѡѼ!');
    Exit;
  end;

 if (apptype=0)and(DTP_3.Date<IncMonth(DTP_1.Date,12)) then
 begin
   ShowMessage('ջɷ!');
   Exit;
 end;
 if (CbBox_1.ItemIndex<>0)and
    (((apptype<>0)and(firstnian>10))
   or((apptype=0)and(firstnian<2))) then
 begin
   ShowMessage('!');
   Exit;
 end;

 if (IncMonth(DTP_1.Date,12*(firstnian-1))>DTP_3.Date) then
 begin
   ShowMessage('Ȼɷ!');
   Exit;
 end;

  niandu:=doyear(DTP_1.Date,DTP_3.Date,-12);
  nianzhi:=doyear(DTP_1.Date,DTP_3.Date,-6);
  if niandu<=firstnian then
  begin
    niandu:=firstnian;
    nianzhi:=firstnian;
  end;

    if (DTP_3.Date>33970)and(DTP_3.Date<34578) then ///1993-01-011994-09-01֮
    begin
      feeshow(apptype,firstnian,niandu,nianzhi,1,CbBox_1.ItemIndex);
    end else
    if (DTP_3.Date>34578)and(DTP_3.Date<36951) then ///1994-09-012001-03-01֮
    begin
      feeshow(apptype,firstnian,niandu,nianzhi,2,CbBox_1.ItemIndex);
    end else
    if DTP_3.Date>36951 then   ///2001-03-01֮
    begin
      feeshow(apptype,firstnian,niandu,nianzhi,3,CbBox_1.ItemIndex);
    end else
    begin   ///1993-01-01֮ǰ
      ShowMessage('1993֮ǰ޷!');
    end;
end;

procedure TForm1.Btn_CloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.CbBox_1Change(Sender: TObject);
begin
  if CbBox_1.ItemIndex<>0 then
    CbBoxShouNian.Enabled:=True
  else
  begin
    CbBoxShouNian.Enabled:=False;
    CbBoxShouNian.ItemIndex:=0;
  end;
end;

procedure TForm1.CbBox_AppTypeChange(Sender: TObject);
begin
  CbBoxShouNian.ItemIndex:=0;
end;

end.
